;#############################################
;SUBRUTINA DE IMPRESION DE MARCADORES Y TILES
;#############################################

EMPEZAMOS:
;impresion marcador de arriba
               LD DE,MARCA		;Primer marcador
               ld hl,txtmarca
               CALL LLAMIMPRIM    ;en impmenu.asm
;impresion marcador de abajo
               LD DE,MARCA2		;Segundo marcador
               ld hl,txtmarca2
               CALL LLAMIMPRIM    ;en impmenu.asm
;impresion vidas
               LD DE,JONHY
               ld hl,life0
               CALL LLAMIMPRIM    ;en impmenu.asm
               LD DE,JONHY        ;no uso push y pop x el ahorro en bytes es 3
               ld hl,life1        ;
               CALL LLAMIMPRIM    ;en impmenu.asm
               LD DE,JONHY
               ld hl,life2
               CALL LLAMIMPRIM    ;en impmenu.asm
               LD DE,JONHY
               ld hl,life3
               CALL LLAMIMPRIM    ;en impmenu.asm
               ret
;impresion del torbellino
IMPRIM_TORBE:
               LD DE,TORBELLINO		;
               ld hl,txttorbe
               CALL LLAMIMPRIM    ;en impmenu.asm
	       RET
;impresion final del juego
IMPRIM_FIN_JUEGO:
               ld de,FIN_GAME
               ld hl,txtfinal
               call LLAMIMPRIM
               ld de,TEXT_FIN_GAME
               ld hl,txtfinaltex
               call LLAMIMPRIM
               ret
imprim_gameover:
               ld de,GAMEOVER
               ld hl,txtgameover
               call LLAMIMPRIM
               RET
txtmarca       defb 48,32,0,0
txtmarca2      defb 16,11,0,22
life0          defb 16,2,24,22
life1          defb 16,2,26,22
life2          defb 16,2,28,22
life3          defb 16,2,30,22
txttorbe       defb 64,8,12,8
txtfinal       defb 40,7,12,8
txtfinaltex    defb 8,6,12,14
txtgameover    defb 40,7,12,14
IMPRMAR        LD A,(AL_TILE)
               LD C,A       ;ALTURA
I_ARRIBA       PUSH HL
               LD A,(AN_TILE)
               LD B,A
I_BU           LD A,(DE)
               LD (HL),A
               INC DE
               INC L
               DJNZ I_BU
               POP HL
               INC H
               LD A,H
               AND 7
               JR NZ,I_SAL2
               LD A,L
               ADD A,32
               LD L,A
               JR C,I_SAL2
               LD A,H
               SUB 8
               LD H,A
I_SAL2         DEC C          ;SACAMOS 8 SCANNES
               JR NZ,I_ARRIBA
IMPATTR_GEN    PUSH DE         ;GUARDAMOS EL CODIGO DEL COLOR
;B=FILA y C=COLUMNA EN CARACTERES
               LD A,(FIL_DAT)
               LD B,A
               LD A,(COL_DAT)
               LD l,A        ;
;llamada a RUTINA DE COORD. DE ATRIBUTOS  DATOS EN INPIX.ASM
               call coordficu
               POP DE
I_AT_NOR       LD A,(AL_TILE)
               SRL A
               SRL A
               SRL A            ;DIVIDIMOS EL ALT_TILE ENTRE 8 PARA QUE EL VALOR SEA EN CHARS.
               LD B,A           ;EL ALTO DEL SPRITE
I_ATB          PUSH BC          ;GUARDAMOS EL ALTO
               PUSH HL          ;LA POSICION DE HL EN A.ATTR
               LD A,(AN_TILE)
               LD B,A
I_ATB1         LD A,(DE)
               LD (HL),A
               INC DE
               INC L
               DJNZ I_ATB1
               POP HL          ;SACAMOS LA POSICION ATTR
               LD C,#20
               ADD HL,BC
               POP BC          ;SACAMOS EL ALTO DEL tile
               DJNZ I_ATB
               RET
;FIN IMPRESION DE MARCADORES
;############################


MARCA
; (Insert graphic label here if needed)

	DEFB	 48,128,  1,  0,  0,  0,232, 55
	DEFB	255,255,247, 38,111, 56,  4,192
	DEFB	  0,  0,  1,131,128, 24,  0, 32
	DEFB	  0,  0,  0,  0,  0,  0,  0,  7
	DEFB	 56,160,  0,  0,  0,  0, 85,127
	DEFB	251,255,255,255,255,255,255, 30
	DEFB	112, 28, 16,255,252, 63, 28,112
	DEFB	121,  0, 64,  0,  0,  0,  0, 63
	DEFB	 56,128,  1,  0,  0,  0, 34,249
	DEFB	197,255,255,255,255,255,255,255
	DEFB	254,127,255,255,255,255,255,252
	DEFB	127,255,252,  1,238,  0, 15,240
	DEFB	 38,104,  4, 64,  0,  0, 85,122
	DEFB	 46,  1,255,255,255,255,255,255
	DEFB	255,255,255,255,255,255,255,255
	DEFB	255,247,255,227,255,255,255,248
	DEFB	 22,176,  1,  0,  0,  0,174,248
	DEFB	240,126,127,255,255,255,255,255
	DEFB	255,255,255,255,255,255,255,255
	DEFB	255,243,255,255,255,255,255,250
	DEFB	 19,255,118,238,136, 32, 87,249
	DEFB	207,255,191,255,255,255,255,255
	DEFB	255,255,255,255,255,255,255,255
	DEFB	255,241,255,255,255,255,255,251
	DEFB	 83,176,  3,128,  0,  0, 47,255
	DEFB	 63,255,199,255,255,193,255,255
	DEFB	255,255,255,255,255,255,255,255
	DEFB	255,245,255,124,  0, 63,255,251
	DEFB	 25,232,  5, 64,  0,  0, 15,254
	DEFB	255,255,  3,255,252, 62,127,255
	DEFB	255,255,255,255,255,255,255, 31
	DEFB	255,246,255, 97,255,199,255,251

	DEFB	 11,128,  1, 16,  0,  0, 27,255
	DEFB	255,  0,135,255,243,255, 32,255
	DEFB	  0,255,255,255,  0,255,252, 15
	DEFB	255,246,255, 95,255,251,255,251
	DEFB	  2, 40,  3,120,  1,192,  5,252
	DEFB	 95,  0,191,255,223,255,  0,255
	DEFB	  0,255,255,255,  0,255,142, 31
	DEFB	255,246,255,127,255,241,255,203
	DEFB	  9,128,  3,248,  3, 96, 74,128
	DEFB	  0,255,  0,  0,  0,  0,255,  0
	DEFB	255,  0,  0,  0, 15,  0,  0,  0
	DEFB	  0,  0,  0,  0,  0,  0,  0,  0
	DEFB	  7,192,  3,144,  4, 32, 21,184
	DEFB	126,192,191,255,255,253,  0,255
	DEFB	  0, 31,255, 27,  0,255, 14,255
	DEFB	254,245,254,127,255,225,254,199
	DEFB	  7, 32,  3, 56,  4,112, 42,187
	DEFB	252,192,191,255,255,253,  0,255
	DEFB	  1, 31,254, 27,128,139,126,255
	DEFB	126,231,249,127,255,239,254,254
	DEFB	  7, 16,  3,248,  3,192, 17,128
	DEFB	  0,225,  0,  0,  0,  0,135,  0
	DEFB	135,  0,  0,  0,255,  0,  0,  0
	DEFB	  0,  0,  0,  0,  0,  0,  0,  0
	DEFB	 14,  0,  3,144,  7,128, 10,187
	DEFB	253,  0,191,207,255,197,  0,255
	DEFB	  1,255,254,251,128, 15,126,254
	DEFB	126,199, 40,127,255,239,254,255
	DEFB	 14,  4,  1, 16,  8, 96, 39,187
	DEFB	253, 16,191,198,252,133, 64,255
	DEFB	 65,255,254,251,128,127,126,254
	DEFB	126,247, 31,127,255,239,254,255

	DEFB	 30,  0,  0,  0,  9,147, 11,128
	DEFB	  0,  0,  0,  0,  0,  0,  0,255
	DEFB	  0,  0,255,  0,  0,  0,  0,  0
	DEFB	  0,  0,  0,  0,  0,255,  0,  0
	DEFB	 28,  0,136,  0,  7, 56, 22, 59
	DEFB	253,239,191,247,200,189,191,  0
	DEFB	190,255,  1,251,127,127,126,252
	DEFB	126,247,191,127,255,  0,254,255
	DEFB	 56, 48,  2,  2,  6,208, 10,187
	DEFB	252,111,255,247,139,189,191,  0
	DEFB	190,255,  1,251,127,127,127,253
	DEFB	254,247,127,127,255,  0,254,227
	DEFB	 56,255, 16,  2, 39, 34, 37,128
	DEFB	  0,  8,  0,  0,  0,  0,  0,195
	DEFB	  0,  0, 15,  0,  0,  0,  0,  0
	DEFB	  0,  0,  0,  0,  0,225,  0,  0
	DEFB	121,255,136, 34,243,192,146,191
	DEFB	253,143,255,255,187,189,191, 32
	DEFB	190,255,129,251,127,124,127,255
	DEFB	254,231,249,127,255, 16,254,199
	DEFB	115,199,128,  7,242, 48, 47, 63
	DEFB	252,111,255,255,187, 61,191, 32
	DEFB	 62,255,129,251,255, 96,127,255
	DEFB	254,199,250,255,255, 16,254,223
	DEFB	115,129,196,  7, 33, 73, 85,128
	DEFB	  0,  0,  0,  0,  0,  0,  0,255
	DEFB	  0,  0,255,  0,  0,  0,  0,  0
	DEFB	  0,  0,  0,  0,  0,255,  0,  0
	DEFB	227,209,193,  2,117,154, 10,191
	DEFB	255,143,255,255,138, 61,191, 33
	DEFB	 63,255,135,251,255, 31,255,255
	DEFB	254,255,255,255,255, 80,254,223

	DEFB	227,184,192,  7,241,168,  4,191
	DEFB	255,255,255,255,177, 61,255,222
	DEFB	 63,255, 96,251,255,255,255,255
	DEFB	254,255,253,255,254,239,254,223
	DEFB	227,108,192, 55, 33,208, 10,191
	DEFB	255,255,255,255,130,125,255,216
	DEFB	 63,255,  3,251,255,255,255,255
	DEFB	254,255,254, 31,195,239,254,223
	DEFB	227,116,192,  2,  4,241, 82, 63
	DEFB	255,255,255,255,177,253,255,192
	DEFB	255,255, 31,251,255,255,255,255
	DEFB	254,255,255,224, 31,255,254,223
	DEFB	243,196,192,  0,240,128, 21, 63
	DEFB	255,255,255,255,143,253,255,199
	DEFB	255,255,127,251,255,255,255,255
	DEFB	254,255,255,255,255,255,254,255
	DEFB	241,228,192,  7,248,132, 40, 63
	DEFB	255,255,255,255,255,253,255,223
	DEFB	255,255,255,251,255,255,255,255
	DEFB	254,255,255,255,255,255,254,255
	DEFB	113,236,192,163, 56, 64,  0, 63
	DEFB	255,255,255,255,255,253,255,255
	DEFB	255,255,255,251,255,255,255,255
	DEFB	254,255,255,255,255,255,254,255
	DEFB	120,249,128,  6, 16, 80,  8, 31
	DEFB	255,255,255,255,255,253,255,255
	DEFB	255,255,255,251,255,255,255,255
	DEFB	254,255,255,255,255,255,254,255
	DEFB	 56, 51,128,  6,  2, 64,  0, 31
	DEFB	255,255,255,255,255,253,255,255
	DEFB	255,255,255,251,255,255,255,255
	DEFB	254,255,255,255,255,255,254,255

	DEFB	 60, 19,  0,  2,  4,  4,128, 47
	DEFB	255,255,255,255,252,253,255,255
	DEFB	255,255,255,251,255,255,255,255
	DEFB	254,255,255,255,255,255,254,255
	DEFB	 30, 30,  0, 14,  0,  4,128, 25
	DEFB	197,255,255,255,255,125,255,255
	DEFB	255,255,255,251,255,255,255,255
	DEFB	254,255,255,255,255,255,254,254
	DEFB	 31,254, 32,194,  1,  7,192, 58
	DEFB	 46,  1,255,255,254,253,255,255
	DEFB	255,255,255,251,255,255,255,255
	DEFB	254,255,255,255,255,255,254,252
	DEFB	 15,248,138,  1, 32, 14,128, 88
	DEFB	240,126,127,255,250,253,255,255
	DEFB	255,255,255,251,255,255,255,255
	DEFB	254,255,255,255,255,255,254,252
	DEFB	  1, 56,  0,  1,194,  4,128, 57
	DEFB	207,255,191,255,248,253,251,255
	DEFB	255,255,255,251,255,255,255,255
	DEFB	254,255,255,255,255,255,254,228
	DEFB	  0,200,  0,  2,  0,  4,128, 95
	DEFB	 63,255,199,255,255, 29,251,255
	DEFB	231,255,255, 59,255,255,255,255
	DEFB	254,240,  0,127,255,255,254,224
	DEFB	  1,232,  0,  8,  4, 15,192, 62
	DEFB	255,255,135,255,248,221,251,254
	DEFB	  7,255,248, 59,255,255,255,255
	DEFB	254,240,  0,127,255,255,254,240
	DEFB	  1,252,  0, 64,  0,  6,128, 47
	DEFB	255,255,135,255,228, 29,251,248
	DEFB	  7,255,192, 59,255,255,255,255
	DEFB	254,247,119,127,255,255,254,240

	DEFB	  1,143, 50,  0,  8,  0,  0, 92
	DEFB	 95,255,191,255,200,221,251,249
	DEFB	135,255,204, 59,255,255,255, 31
	DEFB	254,247,119,127,255,255,254,192
	DEFB	  1,136,  0,  0,  0,  0,  0,  0
	DEFB	  0,  0,  0,  0,  0,  0,  0,  0
	DEFB	  0,  0,  0,  0,  0,  0,  0,  0
	DEFB	  0,  0,  0,  0,  0,  0,  0,252
	DEFB	  0,248,  0,  0, 35,128,  0, 40
	DEFB	126, 63,191,255,192, 29,251,251
	DEFB	247, 31,223,187,143,255,254, 31
	DEFB	126,247,119,127,255,255,254,240
	DEFB	  0,112,  0,  0,  0,102,  0, 19
	DEFB	252, 49,191,255,205,221,195,251
	DEFB	246, 31,223,187, 15,255,142,126
	DEFB	126,247,119,127,252,163,254,240
	DEFB	  0,  0,  0,  0,132,118,  0,  0
	DEFB	  0,  0,  0,  0, 16,  0,  0,  0
	DEFB	  0,  0,  0,  0,  0,  0,  0,  0
	DEFB	  0,  0,  0,  0,  0,  0,  0,  8
	DEFB	  0,  0,  0,  4, 12,112,  0, 17
	DEFB	 93,225,191,207,197, 29,199,251
	DEFB	246,255,223,187,127,255, 14,254
	DEFB	126,247, 28, 97,140,113,142,248
	DEFB	  0,  0,  0, 32, 14, 51,  0, 42
	DEFB	173,239,191,198,221, 61,255,251
	DEFB	246,255,223,187,127,139,126,252
	DEFB	126,224,  0, 62,248, 63,240, 96
	DEFB	  0,  0,  0,  0,  4, 35,  0,  0
	DEFB	  0,  0,  0,  0,  0,  0,  0,  0
	DEFB	  0,  0,  0,  0,  0,  0,  0,  0
	DEFB	  0,  0,  0, 15,240,  3,128,192



; (Attributes here, insert label if needed)

	DEFB	 69, 71, 71, 71, 71, 71, 70, 70
	DEFB	 70, 70, 70, 70, 70, 70, 70, 70
	DEFB	 70, 70, 70, 70, 70, 70, 70, 70
	DEFB	 70, 70, 70, 70, 70, 70, 70, 70
	DEFB	 69, 69, 70,  6, 67, 67, 70, 70
	DEFB	 70,112, 70, 70, 70, 70,112, 70
	DEFB	112, 70, 70, 70,112, 70, 70, 70
	DEFB	 70, 70, 70, 70, 70, 70, 70, 70
	DEFB	  5, 69, 69, 67,  3, 66, 70, 70
	DEFB	 70, 70, 70, 70, 70, 70, 70,112
	DEFB	 70, 70,112, 70, 70, 70, 70, 70
	DEFB	 70, 70, 70, 70, 70,112, 70, 70
	DEFB	  5,  5, 69, 67, 67, 66,  6, 70
	DEFB	 70, 70, 70, 70, 70, 70, 70, 70
	DEFB	 70, 70, 70, 70, 70, 70, 70, 70
	DEFB	 70, 70, 70, 70, 70, 70, 70, 70
	DEFB	  5,  5, 69, 66,  2, 65,  1, 70
	DEFB	 70, 70, 70, 70, 70, 70, 70, 70
	DEFB	 70, 70, 70, 70, 70, 70, 70, 70
	DEFB	 70, 70, 70, 70, 70, 70, 70, 70
	DEFB	 69,  5,  5, 67, 66,  2, 71, 70
	DEFB	 70, 70, 70, 70, 70, 70, 70, 70
	DEFB	 70, 70, 70, 70, 70, 70, 70, 70
	DEFB	 70, 70, 70, 70, 70, 70, 70, 70

MARCA2
	DEFB	 12,224,  0,  0,128,  0,  0,  0
	DEFB	  0,  5, 80
	DEFB	  8,160,  0,  0,224,  0,  0,  0
	DEFB	  0,  0,192
	DEFB	 13, 96,  0,  3,248,  0, 16,  0
	DEFB	  0,  0,160
	DEFB	  4,214,  0,  3,252,  0,102,  0
	DEFB	  0,  6,224
	DEFB	  8,179,  0,  7,255, 64, 11, 46
	DEFB	  0,  3,112
	DEFB	  6, 41,  0,  7,227,252,  0,101
	DEFB	224,109, 96
	DEFB	  5,108, 64,  7,192, 31,200,193
	DEFB	248,181,224
	DEFB	  1, 27,248, 31,  0,  1,244, 40
	DEFB	126,215,192

	DEFB	  0, 26,188, 30,  0,  0,122, 64
	DEFB	119, 94,128
	DEFB	  0,  6,175,247, 64,  0, 60,  4
	DEFB	 30,120,  0
	DEFB	  0, 13,106,255,240,  0, 63, 17
	DEFB	 31, 32,  0
	DEFB	  0,  3, 90,127,224,  0, 14,  7
	DEFB	 13, 32,  0
	DEFB	  0,  2,215,127, 64,  0,  5,  0
	DEFB	 76,  0,  0
	DEFB	  0,  0,181,255,160,  8, 43,137
	DEFB	136,  0,  0
	DEFB	  0,  0,108,255,212,  0,213,  3
	DEFB	  8,  0,  0
	DEFB	  0,  0, 30, 14,168,  8, 58,132
	DEFB	 64,  0,  0

; (Attributes here, insert label if needed)

	DEFB	  6, 67, 67, 66, 66, 66,  2,  2
	DEFB	  2, 3, 6
	DEFB	 66, 3, 3, 66,  2,  6, 66,  2
	DEFB	 66,  67,  67

;JONHY_VIDAS
JONHY:

; (Insert graphic label here if needed)

	DEFB	  3,156
	DEFB	  0,110
	DEFB	 13,151
	DEFB	 60,139
	DEFB	126, 66
	DEFB	121,220
	DEFB	118,252
	DEFB	 60,208

	DEFB	  0,  0
	DEFB	  1,208
	DEFB	  2,152
	DEFB	  3,104
	DEFB	  2, 96
	DEFB	  0,  0
	DEFB	  5,144
	DEFB	 14,248
; (Attributes here, insert label if needed)
	DEFB	  70, 6
	DEFB	  66, 3

